// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#include "consumer.hpp"

#include "timeProfileConsts.hpp"

#include <iostream>

consumer::consumer( contentionPoint * const sharedResource,
		    const workModel& consumptionWork ) :
  contention( sharedResource ),
  workToConsume( consumptionWork )
{
  this->profiler.reset( new timeProfile );
}

consumer::consumer( const consumer& copy ) :
  contention( copy.contention ),
  workToConsume( copy.workToConsume ),
  profiler( copy.profiler )
{
}

consumer::~consumer()
{
}

void consumer::operator()( void )
{
  this->profiler->insertProfilePoint( CONSUMER_ID | 1 );

  while( this->contention->consume( *(this->profiler) ) )
  {
    this->workToConsume.doWork( *(this->profiler) );
  }

  this->profiler->insertProfilePoint( CONSUMER_ID | 2 );
}

const timeProfile& consumer::getProfiler( void ) const
{
  return( *(this->profiler) );
}
