// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#ifndef CONSUMER_HPP
#define CONSUMER_HPP

#include <boost/shared_ptr.hpp>

#include "workModel.hpp"
#include "contentionPoint.hpp"
#include "timeProfile.hpp"

class consumer
{
public:

  consumer( contentionPoint * const sharedResource,
	    const workModel& consumptionWork );
  consumer( const consumer& copy );
  ~consumer();

  void operator()( void );
  const timeProfile& getProfiler( void ) const;

private:

  boost::shared_ptr<timeProfile> profiler;
  workModel workToConsume;
  contentionPoint * const contention;

  consumer();
};

#endif
