// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#include "gaussianRandomVariable.hpp"

#include <stdlib.h>
#include <math.h>

#include "throughputException.hpp"

gaussianRandomVariable::gaussianRandomVariable(
	const unsigned long expectedValue,
	const unsigned long standardDeviation ) :
		mean( static_cast<double>( expectedValue ) ),
		stdDev( static_cast<double>( standardDeviation ) ),
		distrib( static_cast<double>( expectedValue ), static_cast<double>( standardDeviation ) ),
		normGen( randomGen, distrib )
{
}

gaussianRandomVariable::gaussianRandomVariable( const gaussianRandomVariable& copy ) :
	mean( copy.mean ),
	stdDev( copy.stdDev ),
	distrib( copy.distrib ),
	normGen( copy.normGen )
{
}

gaussianRandomVariable::~gaussianRandomVariable()
{
}

const unsigned long gaussianRandomVariable::getSample( void )
{
	return( static_cast<const unsigned long>( this->normGen() ) );
}
