// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#ifndef GAUSSIANRANDOMVARIABLE_HPP
#define GAUSSIANRANDOMVARIABLE_HPP

#include <boost/random.hpp>
#include <boost/random/normal_distribution.hpp>
#include <boost/random/variate_generator.hpp>

class gaussianRandomVariable
{
public:

	gaussianRandomVariable( const unsigned long expectedValue,
		const unsigned long standardDeviation );
	gaussianRandomVariable( const gaussianRandomVariable& copy );
	~gaussianRandomVariable();

	const unsigned long getSample( void );

private:

	const double mean;
	const double stdDev;
	boost::mt19937 randomGen;
	boost::normal_distribution<double> distrib;
	boost::variate_generator<boost::mt19937,boost::normal_distribution<double> > normGen;

	gaussianRandomVariable();
};

#endif
