// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#ifndef IODEVICE_HPP
#define IODEVICE_HPP

#include <boost/thread/thread.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>

#include "timeProfile.hpp"

class ioDevice
{
public:

  static ioDevice* getInstance( void );

  void doIo(
    const unsigned long numNanoSecsIo,
    timeProfile& profile );

private:

  const unsigned maxNumIoThreads;
  const unsigned long pollingIntervalMicroSecs;
  unsigned numThreadsDoingIo;
  boost::mutex lock;

  ioDevice();
};

#endif
