// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#include "producer.hpp"

#include "timeProfileConsts.hpp"

#include <iostream>

producer::producer( contentionPoint * const sharedResource,
		    const workModel& productionWork ) :
  contention( sharedResource ),
  workToProduce( productionWork )
{
  this->profiler.reset( new timeProfile );
}

producer::producer( const producer& copy ) :
  contention( copy.contention ),
  workToProduce( copy.workToProduce ),
  profiler( copy.profiler )
{
}

producer::~producer()
{
}

const timeProfile& producer::getProfiler( void ) const
{
  return( *(this->profiler) );
}

void producer::operator()( void )
{
  this->profiler->insertProfilePoint( PRODUCOR_ID | 1 );
  while( this->contention->produce( *(this->profiler) ) )
  {
    this->workToProduce.doWork( *(this->profiler) );
  }
  this->profiler->insertProfilePoint( PRODUCOR_ID | 2 );
}
