// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#ifndef PRODUCER_HPP
#define PRODUCER_HPP

#include <boost/shared_ptr.hpp>

#include "workModel.hpp"
#include "contentionPoint.hpp"
#include "timeProfile.hpp"

class producer
{
public:

  producer( contentionPoint * const sharedResource,
	    const workModel& productionWork );
  producer( const producer& copy );
  ~producer();

  void operator()( void );
  const timeProfile& getProfiler( void ) const;

private:

  boost::shared_ptr<timeProfile> profiler;
  workModel workToProduce;
  contentionPoint * const contention;

  producer();
};

#endif
