// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#ifndef PROFILEAGREGATE_HPP
#define PROFILEAGREGATE_HPP

#include <list>
#include <fstream>

#include "timeProfile.hpp"
#include "throughputControl.hpp"

class profileAgregate
{
public:

  class profileResultsType
  {
  public:

    profileResultsType( 
      throughputControl const * const theControl,
      timeProfile const * const theProfile );
    profileResultsType( const profileResultsType& copy );

    throughputControl const * const control;
    timeProfile const * const profile;

  private:
    profileResultsType();
  };

  profileAgregate();
  profileAgregate( const profileAgregate& copy );
  ~profileAgregate();

  void insertProfileResults( const throughputControl& controlParams,
			     const timeProfile& profResults );

  const std::list<profileResultsType>& getAgregatedResults( void ) const;
  void printHeader( std::ostream& str ) const;

private:

  std::list<profileResultsType> agregate;

};

std::ostream& operator<<( std::ostream& str, const profileAgregate& obj );

#endif
