// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#ifndef THROUGHPUTCONFIGFILE_HPP
#define THROUGHPUTCONFIGFILE_HPP

#include <string>
#include <list>

#include "throughputControl.hpp"

class throughputConfigFile
{
public:

  throughputConfigFile( const std::string& confFileName );
  throughputConfigFile( const throughputConfigFile& copy );
  ~throughputConfigFile();

  const std::list<throughputControl>& getTestControls( void ) const;

private:

  const unsigned numParamsPerLine;
  const std::string fileName;
  std::list<throughputControl> testControlList;

  throughputConfigFile();
  void readInConfigFile( void );
};

#endif
