// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#include "timeProfile.hpp"

#include "throughputException.hpp"

timeProfile::timeProfile() :
	vectorInitialSize( 500 ),
	threadIdentifier( boost::this_thread::get_id() )
{
	this->profilePoints.reset(
		new std::vector<timeProfilePoint>( this->vectorInitialSize ) );
	this->profilePoints->clear();
}

timeProfile::timeProfile( const timeProfile& copy ) :
vectorInitialSize( copy.vectorInitialSize ),
	threadIdentifier( copy.threadIdentifier )
{
	this->profilePoints.reset(
		new std::vector<timeProfilePoint>( *(copy.profilePoints) ) );
}

timeProfile::~timeProfile()
{
}

const std::vector<timeProfile::timeProfilePoint>&
	timeProfile::getProfilePoints( void ) const
{
	return( *(this->profilePoints) );
}

const boost::thread::id timeProfile::getThreadId( void ) const
{
	return( this->threadIdentifier );
}

void timeProfile::insertProfilePoint( const unsigned locationIdent )
{
	timeProfilePoint newPoint;
	newPoint.locationId = locationIdent;
	newPoint.time = boost::posix_time::microsec_clock::local_time();
	this->profilePoints->push_back( newPoint );
}
