// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#ifndef TIMEPROFILE_HPP
#define TIMEPROFILE_HPP

#include <vector>
#include <memory>
#include <boost/thread/thread.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>

class timeProfile
{
public:

  struct timeProfilePoint
  {
    unsigned locationId;
	boost::posix_time::ptime time;
  };

  timeProfile();
  timeProfile( const timeProfile& copy );
  ~timeProfile();

  const std::vector<timeProfilePoint>& getProfilePoints( void ) const;
  const boost::thread::id getThreadId( void ) const;
  void insertProfilePoint( const unsigned locationIdent );

private:

  const unsigned vectorInitialSize;
  const boost::thread::id threadIdentifier;
  std::auto_ptr<std::vector<timeProfilePoint> > profilePoints;
};

#endif
