// Copyright 2009 - Paul S. Heidmann
//
// Unless changed, in writing, by Paul S. Heidmann, this code is
// governed by the GPL, version 3. The terms of this copyright
// are found in the file throughputTest.cpp, included in this
// distribution.
//

#ifndef WORKMODEL_HPP
#define WORKMODEL_HPP

#include <memory>
#include <boost/random.hpp>

#include "gaussianRandomVariable.hpp"
#include "timeProfile.hpp"

class workModel
{
public:

	workModel( const gaussianRandomVariable& workIterationsVar );
	workModel( const gaussianRandomVariable& workIterationsVar,
		const gaussianRandomVariable& ioNanoSecsWaitVar );
	workModel( const workModel& copy );
	~workModel();

	double doWork( timeProfile& prof );

private:

	const bool hasIoVar;
	boost::mt19937 randNumGen;
	boost::uniform_real<> uniReal;
	boost::variate_generator<boost::mt19937, boost::uniform_real<> > randObj;

	std::auto_ptr<gaussianRandomVariable> iterVar;
	std::auto_ptr<gaussianRandomVariable> ioVar;
	workModel();
};

#endif
